import proj4 from "proj4"

/**
 * 坐标转换工具类
 */
const ProjUtils = {
  // 3857
  WebMercator: '+proj=merc +a=6378137 +b=6378137 +lat_ts=0 +lon_0=0 +x_0=0 +y_0=0 +k=1 +units=m +nadgrids=@null +wktext +no_defs +type=crs',
  // 4326
  WGS84: '+proj=longlat +datum=WGS84 +no_defs +type=crs',

  // 4490
  CGCS2000: '+proj=longlat +ellps=GRS80 +no_defs +type=crs',

  // 佛山2000坐标系proj4字符串
  FS2000: '+proj=tmerc +lat_0=0 +lon_0=113 +k=1 +x_0=700000 +y_0=0 +ellps=GRS80 +units=m +no_defs +type=crs',

  /**
   * 4490转fs2000
   * @param {Number[]} lonLat -经纬度坐标
   *
   * @returns {Number[]} 投影坐标
   */
  toFs2000(lonLat) {
    return proj4(this.CGCS2000, this.FS2000, lonLat);
  },
  toCGCS2000(lonLat) {
    return proj4(this.FS2000, this.CGCS2000, lonLat);
  },
};

export default ProjUtils;
